using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace RDH.Data.Models
{
    [Serializable]
    [DataContract]
    public partial class PortableStorageItemLot : BaseModel
    {
        #region Fields
        private Guid _key;
        private Double? _quantity;
        private Guid? _createby;
        private Guid? _itemkey;
        private Guid? _lotkey;
        private Guid? _portableStorageItemkey;
        private bool? _flag;
        private DateTime? _clienttime;
        private DateTime? _servertime;
        private string _ext01;
        private string _ext02;
        private string _ext03;
        private string _ext04;
        private string _ext05;
        private string _ext06;
        private string _ext07;
        private string _ext08;
        private string _ext09;
        private string _ext10;
        private ItemLot _itemlot;
        private Item _item;
        private PortableStorageItem _portableStorageItem;
        #endregion

        #region Public Properties
        [DataMember]
        public virtual Guid Key
        {
            get { return _key; }
            set
            {
                _key = value;
                OnPropertyChanged("Key");
            }
        }
        [DataMember]
        public virtual Double? Quantity
        {
            get { return _quantity; }
            set
            {
                _quantity = value;
                OnPropertyChanged("Quantity");
            }
        }
        [DataMember]
        public virtual Guid? CreateBy
        {
            get { return _createby; }
            set
            {
                _createby = value;
                OnPropertyChanged("CreateBy");
            }
        }
        [DataMember]
        public virtual Guid? ItemKey
        {
            get { return _itemkey; }
            set
            {
                _itemkey = value;
                OnPropertyChanged("ItemKey");
            }
        }
        [DataMember]
        public virtual Guid? LotKey
        {
            get { return _lotkey; }
            set
            {
                _lotkey = value;
                OnPropertyChanged("LotKey");
            }
        }
        [DataMember]
        public virtual Guid? PortableStorageItemkey
        {
            get { return _portableStorageItemkey; }
            set
            {
                _portableStorageItemkey = value;
                OnPropertyChanged("StorageSapceItemKey");
            }
        }
        [DataMember]
        public virtual bool? Flag
        {
            get { return _flag; }
            set
            {
                _flag = value;
                OnPropertyChanged("Flag");
            }
        }
        [DataMember]
        public virtual DateTime? ClientTime
        {
            get { return _clienttime; }
            set
            {
                _clienttime = value;
                OnPropertyChanged("ClientTime");
            }
        }
        [DataMember]
        public virtual DateTime? ServerTime
        {
            get { return _servertime; }
            set
            {
                _servertime = value;
                OnPropertyChanged("ServerTime");
            }
        }
        [DataMember]
        public virtual string Ext01
        {
            get { return _ext01; }
            set
            {
                _ext01 = value;
                OnPropertyChanged("Ext01");
            }
        }
        [DataMember]
        public virtual string Ext02
        {
            get { return _ext02; }
            set
            {
                _ext02 = value;
                OnPropertyChanged("Ext02");
            }
        }
        [DataMember]
        public virtual string Ext03
        {
            get { return _ext03; }
            set
            {
                _ext03 = value;
                OnPropertyChanged("Ext03");
            }
        }
        [DataMember]
        public virtual string Ext04
        {
            get { return _ext04; }
            set
            {
                _ext04 = value;
                OnPropertyChanged("Ext04");
            }
        }
        [DataMember]
        public virtual string Ext05
        {
            get { return _ext05; }
            set
            {
                _ext05 = value;
                OnPropertyChanged("Ext05");
            }
        }
        [DataMember]
        public virtual string Ext06
        {
            get { return _ext06; }
            set
            {
                _ext06 = value;
                OnPropertyChanged("Ext06");
            }
        }
        [DataMember]
        public virtual string Ext07
        {
            get { return _ext07; }
            set
            {
                _ext07 = value;
                OnPropertyChanged("Ext07");
            }
        }
        [DataMember]
        public virtual string Ext08
        {
            get { return _ext08; }
            set
            {
                _ext08 = value;
                OnPropertyChanged("Ext08");
            }
        }
        [DataMember]
        public virtual string Ext09
        {
            get { return _ext09; }
            set
            {
                _ext09 = value;
                OnPropertyChanged("Ext09");
            }
        }
        [DataMember]
        public virtual string Ext10
        {
            get { return _ext10; }
            set
            {
                _ext10 = value;
                OnPropertyChanged("Ext10");
            }
        }
        [DataMember]
        public ItemLot ItemLot
        {
            get { return _itemlot; }
            set
            {
                _itemlot = value;
                OnPropertyChanged("ItemLot");
            }
        }
        [DataMember]
        public Item Item
        {
            get { return _item; }
            set
            {
                _item = value;
                OnPropertyChanged("Item");
            }
        }
        [DataMember]
        public PortableStorageItem PortableStorageItem
        {
            get { return _portableStorageItem; }
            set
            {
                _portableStorageItem = value;
                OnPropertyChanged("PortableStorageItem");
            }
        }

        #endregion
        public PortableStorageItemLot Clone()
        {
            return new PortableStorageItemLot()
            {
                _clienttime = this._clienttime,
                _createby = this._createby,
                _createtime = this._createtime,
                _ext01 = this._ext01,
                _ext02 = this._ext02,
                _ext03 = this._ext03,
                _ext04 = this._ext04,
                _ext05 = this._ext05,
                _ext06 = this._ext06,
                _ext07 = this._ext07,
                _ext08 = this._ext08,
                _ext09 = this._ext09,
                _ext10 = this._ext10,
                _flag = this._flag,
                _item = this._item,
                _itemkey = this._itemkey,
                _itemlot = this._itemlot,
                _key = this._key,
                _lotkey = this._lotkey,
                _quantity = this._quantity,
                _servertime = this._servertime,
                _portableStorageItemkey = this._portableStorageItemkey,
                _portableStorageItem = this._portableStorageItem,
            };
        }
    }
}
